# 1 "build/generated/bootblock_inc.S"
# 1 "<built-in>"
# 1 "<command-line>"
# 1 "./build/build.h" 1
# 1 "<command-line>" 2
# 1 "./build/config.h" 1
# 1 "<command-line>" 2
# 1 "build/generated/bootblock_inc.S"
# 1 "./src/arch/x86/init/prologue.inc" 1
# 20 "./src/arch/x86/init/prologue.inc"
# 1 "src/include/cpu/x86/post_code.h" 1

# 1 "src/include/console/post_codes.h" 1
# 3 "src/include/cpu/x86/post_code.h" 2
# 21 "./src/arch/x86/init/prologue.inc" 2

.section ".rom.data", "a", @progbits
.section ".rom.text", "ax", @progbits
# 2 "build/generated/bootblock_inc.S" 2
# 1 "./src/cpu/x86/16bit/entry16.inc" 1
# 30 "./src/cpu/x86/16bit/entry16.inc"
# 1 "src/arch/x86/include/arch/rom_segs.h" 1
# 31 "./src/cpu/x86/16bit/entry16.inc" 2
.code16
.globl _start
.type _start, @function

_start:
 cli

 movl %eax, %ebp

 movb $0x01, %al; outb %al, $0x80







 xorl %eax, %eax
 movl %eax, %cr3
# 101 "./src/cpu/x86/16bit/entry16.inc"
 movw %cs, %ax
 shlw $4, %ax
 movw $nullidt_offset, %bx
 subw %ax, %bx
 lidt %cs:(%bx)
 movw $gdtptr16_offset, %bx
 subw %ax, %bx
 lgdtl %cs:(%bx)

 movl %cr0, %eax
 andl $0x7FFAFFD1, %eax
 orl $0x60000001, %eax
 movl %eax, %cr0


 movl %ebp, %eax


 ljmpl $0x08, $__protected_start





.align 4
.globl gdtptr16
gdtptr16:
 .word gdt_end - gdt -1
 .long gdt

.align 4
.globl nullidt
nullidt:
 .word 0
 .long 0
 .word 0

.globl _estart
_estart:
 .code32
# 3 "build/generated/bootblock_inc.S" 2
# 1 "./src/cpu/x86/16bit/reset16.inc" 1
 .section ".reset"
 .code16
.globl reset_vector
reset_vector:
 .byte 0xe9
 .int _start - ( . + 2 )






 .org 0x8;
 .code32
 jmp protected_start
 .previous
# 4 "build/generated/bootblock_inc.S" 2
# 1 "./src/cpu/x86/32bit/entry32.inc" 1



# 1 "src/include/cpu/x86/post_code.h" 1
# 5 "./src/cpu/x86/32bit/entry32.inc" 2

 .code32







 .align 4
.globl gdtptr
gdt:
gdtptr:
 .word gdt_end - gdt -1
 .long gdt
 .word 0


 .word 0xffff, 0x0000
 .byte 0x00, 0x9b, 0xcf, 0x00


 .word 0xffff, 0x0000
 .byte 0x00, 0x93, 0xcf, 0x00


 .word 0xffff, 0x0000
 .byte 0x00, 0x9b, 0xaf, 0x00

gdt_end:
# 48 "./src/cpu/x86/32bit/entry32.inc"
 .align 4
.globl protected_start
protected_start:

 lgdt %cs:gdtptr
 ljmp $0x08, $__protected_start

__protected_start:

 movl %eax, %ebp

 movb $0x10, %al; outb %al, $0x80

 movw $0x10, %ax
 movw %ax, %ds
 movw %ax, %es
 movw %ax, %ss
 movw %ax, %fs
 movw %ax, %gs


 movl %ebp, %eax
# 5 "build/generated/bootblock_inc.S" 2
# 1 "./src/arch/x86/lib/id.inc" 1
 .section ".id", "a", @progbits

 .globl __id_start
__id_start:
ver:
 .asciz "4.0-7786-g6d82285-dirty"
vendor:
 .asciz "ASROCK"
part:
 .asciz "E350M1"
.long __id_end + 0x80 - ver
.long __id_end + 0x80 - vendor
.long __id_end + 0x80 - part
.long 0x400000
 .globl __id_end

__id_end:
.previous
# 6 "build/generated/bootblock_inc.S" 2
# 1 "./build/generated/bootblock.inc" 1
.section ".rom.data"
.balign 16
L1:
.int 0xff, 0, 0, 0
L2:
.int 0xffff, 0, 0, 0
.section ".rom.text"

L1001:
L1002:

.section ".rom.data"
.balign 1
L1003:
.byte 0x66
.byte 0x61
.byte 0x6c
.byte 0x6c
.byte 0x62
.byte 0x61
.byte 0x63
.byte 0x6b
.byte 0x2f
.byte 0x72
.byte 0x6f
.byte 0x6d
.byte 0x73
.byte 0x74
.byte 0x61
.byte 0x67
.byte 0x65
.byte 0x00
.section ".rom.text"


#ASM

#NOT ASM

 mov %eax, %ebp







 mov $27 , %ecx
 rdmsr
# 58 "./build/generated/bootblock.inc"
 and $256 , %eax

 test %eax, %eax
 jz L1005
L1004:
# 80 "./build/generated/bootblock.inc"
 mov $-2147441852 , %eax
 mov $3320 , %dx
 outl %eax, %dx
# 93 "./build/generated/bootblock.inc"
 mov $3324 , %dx
 inl %dx, %eax
# 118 "./build/generated/bootblock.inc"
 mov $-2147441852 , %eax
 mov $3320 , %dx
 outl %eax, %dx
# 131 "./build/generated/bootblock.inc"
 mov $-1 , %eax
 mov $3324 , %dx
 outl %eax, %dx
# 151 "./build/generated/bootblock.inc"
 mov $-2147441848 , %eax
 mov $3320 , %dx
 outl %eax, %dx
# 164 "./build/generated/bootblock.inc"
 mov $3324 , %dx
 inl %dx, %eax






 or $2097235 , %eax
 mov %eax, %esp
# 191 "./build/generated/bootblock.inc"
 mov $-2147441848 , %eax
 mov $3320 , %dx
 outl %eax, %dx
# 204 "./build/generated/bootblock.inc"
 mov $3324 , %dx
 mov %esp, %eax
 outl %eax, %dx
# 224 "./build/generated/bootblock.inc"
 mov $-2147441812 , %eax
 mov $3320 , %dx
 outl %eax, %dx
# 237 "./build/generated/bootblock.inc"
 mov $3324 , %dx
 inw %dx, %ax
# 262 "./build/generated/bootblock.inc"
 mov $-2147441812 , %eax
 mov $3320 , %dx
 outl %eax, %dx
# 275 "./build/generated/bootblock.inc"
 mov $65472 , %ax
 mov $3324 , %dx
 outw %ax, %dx
# 295 "./build/generated/bootblock.inc"
 mov $-2147441736 , %eax
 mov $3320 , %dx
 outl %eax, %dx
# 308 "./build/generated/bootblock.inc"
 mov $3324 , %dx
 inl %dx, %eax
# 322 "./build/generated/bootblock.inc"
 or $16777216 , %eax
 mov %eax, %esp
# 341 "./build/generated/bootblock.inc"
 mov $-2147441736 , %eax
 mov $3320 , %dx
 outl %eax, %dx
# 354 "./build/generated/bootblock.inc"
 mov $3324 , %dx
 mov %esp, %eax
 outl %eax, %dx






 mov $-1610612736 , %esp
# 381 "./build/generated/bootblock.inc"
 mov $-2147441760 , %eax
 mov $3320 , %dx
 outl %eax, %dx
# 394 "./build/generated/bootblock.inc"
 mov $3324 , %dx
 inl %dx, %eax
 mov %eax, %edi






 mov %esp, %esi






 or $2 , %esi
# 428 "./build/generated/bootblock.inc"
 mov $-2147441760 , %eax
 mov $3320 , %dx
 outl %eax, %dx
# 441 "./build/generated/bootblock.inc"
 mov $3324 , %dx
 mov %esi, %eax
 outl %eax, %dx






 mov %esp, %esi
 add $12 , %esi






 movl (%esi), %esi
# 471 "./build/generated/bootblock.inc"
 and $-49153 , %esi
# 484 "./build/generated/bootblock.inc"
 or $16384 , %esi






 mov %esp, %edx
 add $12 , %edx






 movl %esi, (%edx)






 mov %esp, %esi
 add $0 , %esi






 movl (%esi), %esi
# 527 "./build/generated/bootblock.inc"
 or $262144 , %esi






 add $0 , %esp






 movl %esi, (%esp)
# 559 "./build/generated/bootblock.inc"
 mov $-2147441760 , %eax
 mov $3320 , %dx
 outl %eax, %dx
# 572 "./build/generated/bootblock.inc"
 mov $3324 , %dx
 mov %edi, %eax
 outl %eax, %dx
# 587 "./build/generated/bootblock.inc"
 mov $-19395008 , %esp
# 597 "./build/generated/bootblock.inc"
 mov $36 , %al
 mov $3286 , %dx
 outb %al, %dx
# 609 "./build/generated/bootblock.inc"
 mov $3287 , %dx
 inb %dx, %al
 movzx %al, %edi






 or $1 , %edi






 and $-3 , %edi
 mov %edi, %eax
# 636 "./build/generated/bootblock.inc"
 mov $3287 , %dx
 outb %al, %dx






 movl (%esp), %edi






 and $-8 , %edi






 or $2 , %edi






 movl %edi, (%esp)

L1005:







 mov $L1003+0 , %esi
#ASM
 mov $1f, %esp
 jmp walkcbfs_asm
 1:

#NOT ASM
# 693 "./build/generated/bootblock.inc"
 mov %eax, %esp





 cmp $0 , %esp
 jz L1007
L1006:





 mov %eax, %esp
 add $20 , %esp





 movl (%esp), %esp





 and $255 , %esp





 shl $24 , %esp





 mov %eax, %edi
 add $20 , %edi





 movl (%edi), %edi





 and $65280 , %edi





 shl $8 , %edi





 or %edi, %esp





 mov %eax, %edi
 add $20 , %edi





 movl (%edi), %edi





 and $16711680 , %edi





 shr $8 , %edi





 or %edi, %esp





 mov %eax, %edi
 add $20 , %edi





 movl (%edi), %edi





 and $-16777216 , %edi





 shr $24 , %edi





 or %edi, %esp
# 840 "./build/generated/bootblock.inc"
 add %esp, %eax





 mov %eax, %esp





 jmp L1008





L1007:





 mov $0 , %esp





L1008:
# 884 "./build/generated/bootblock.inc"
 mov %esp, %edi




 cmp $0 , %edi
 jz L1010
L1009:




 add $4 , %esp




 movl (%esp), %esp




 jmp L1011




L1010:




 mov $0 , %esp




L1011:





 test %esp, %esp
 jz L1014
L1012:




 mov %ebp, %eax
#ASM
 jmp *%esp

#NOT ASM




 jmp L1014
L1013:






 hlt




L1014:
 jmp L1013





#ASM

#NOT ASM
# 7 "build/generated/bootblock_inc.S" 2
# 1 "./src/arch/x86/lib/walkcbfs.S" 1
# 24 "./src/arch/x86/lib/walkcbfs.S"
walkcbfs_asm:
 cld

 mov 0xfffffffc, %eax
 mov ((0 + 4) + 4)(%eax), %ecx
 bswap %ecx
 mov $0, %ebx
 sub %ecx, %ebx
 mov (((((0 + 4) + 4) + 4) + 4) + 4)(%eax), %ecx
 bswap %ecx
 add %ecx, %ebx


 mov $0, %eax
1:
 cmpb $0, (%eax,%esi)
 jz 2f
 add $1, %eax
 jmp 1b
2:
 add $1, %eax
walker:
 mov 0(%ebx), %edi
 cmp %edi, filemagic
 jne searchfile
 mov 4(%ebx), %edi
 cmp %edi, filemagic+4
 jne searchfile


 mov %ebx, %edi
 add $(((((0 + 8) + 4) + 4) + 4) + 4), %edi
 mov %eax, %ecx
 repe cmpsb

 jnz tryharder


 mov %ebx, %eax
 jmp *%esp

tryharder:
 sub %ebx, %edi
 sub $(((((0 + 8) + 4) + 4) + 4) + 4), %edi
 sub %edi, %esi


 mov ((((0 + 8) + 4) + 4) + 4)(%ebx), %ecx
 bswap %ecx
 add %ebx, %ecx
 mov (0 + 8)(%ebx), %edi
 bswap %edi
 add %edi, %ecx
 mov 0xfffffffc, %edi
 mov ((((0 + 4) + 4) + 4) + 4)(%edi), %edi
 bswap %edi
 sub $1, %edi
 add %edi, %ecx
 not %edi
 and %edi, %ecx


 cmp %ebx, %ecx
 jbe out

 mov %ecx, %ebx

check_for_exit:

 mov 0xfffffffc, %ecx
 mov (((0 + 4) + 4) + 4)(%ecx), %ecx
 bswap %ecx
 not %ecx
 add $1, %ecx

 cmp %ecx, %ebx

 jbe walker

out:
 mov $0, %eax
 jmp *%esp


searchfile:

 mov 0xfffffffc, %edi
 mov ((((0 + 4) + 4) + 4) + 4)(%edi), %edi
 bswap %edi
 add %edi, %ebx
 jmp check_for_exit

filemagic:
 .ascii "LARCHIVE"
# 7 "build/generated/bootblock_inc.S" 2
