DefinitionBlock (
 "DSDT.AML",
 "DSDT",
 0x02,
 "ASROCK",
 "COREBOOT",
 0x00010001
 )
{
Name(LOMH, 0x0)
Name(PBAD, 0x0)
Name(PBLN, 0x0)
Name(PCBA, 0xF8000000)
Name(HPBA, 0xFED00000)
Name(SSFG, 0x0D)
Name(OSVR, 3)
Name(OSV, Ones)
Name(PMOD, One)
Scope(\_SB) {
 Method(OSFL, 0){
  if(LNotEqual(OSVR, Ones)) {Return(OSVR)}
  if(CondRefOf(\_OSI,Local1))
  {
   Store(1, OSVR)
   if (\_OSI("Windows 2006"))
   {
    Store(2, OSVR)
   }
  } else {
   If(WCMP(\_OS,"Linux")) {
    Store(3, OSVR)
   } Else {
    Store(4, OSVR)
   }
  }
  Return(OSVR)
 }
}
Scope(\_SI) {
 Method(_SST, 1) {
 }
}
Scope (\_PR) {
 Processor(
  C000,
  0,
  0x810,
  0x06
  ) {
 }
 Processor(
  C001,
  1,
  0x810,
  0x06
  ) {
 }
}
Scope(\_SB) {
 Name(PR0, Package(){
  Package(){0x0001FFFF, 0, INTC, 0 },
  Package(){0x0001FFFF, 1, INTD, 0 },
  Package(){0x0002FFFF, 0, INTC, 0 },
  Package(){0x0002FFFF, 1, INTD, 0 },
  Package(){0x0002FFFF, 2, INTA, 0 },
  Package(){0x0002FFFF, 3, INTB, 0 },
  Package(){0x0003FFFF, 0, INTD, 0 },
  Package(){0x0003FFFF, 1, INTA, 0 },
  Package(){0x0003FFFF, 2, INTB, 0 },
  Package(){0x0003FFFF, 3, INTC, 0 },
  Package(){0x0004FFFF, 0, INTA, 0 },
  Package(){0x0004FFFF, 1, INTB, 0 },
  Package(){0x0004FFFF, 2, INTC, 0 },
  Package(){0x0004FFFF, 3, INTD, 0 },
  Package(){0x0005FFFF, 0, INTB, 0 },
  Package(){0x0005FFFF, 1, INTC, 0 },
  Package(){0x0005FFFF, 2, INTD, 0 },
  Package(){0x0005FFFF, 3, INTA, 0 },
  Package(){0x0006FFFF, 0, INTC, 0 },
  Package(){0x0006FFFF, 1, INTD, 0 },
  Package(){0x0006FFFF, 2, INTA, 0 },
  Package(){0x0006FFFF, 3, INTB, 0 },
  Package(){0x0007FFFF, 0, INTD, 0 },
  Package(){0x0007FFFF, 1, INTA, 0 },
  Package(){0x0007FFFF, 2, INTB, 0 },
  Package(){0x0007FFFF, 3, INTC, 0 },
  Package(){0x0009FFFF, 0, INTB, 0 },
  Package(){0x0009FFFF, 1, INTC, 0 },
  Package(){0x0009FFFF, 2, INTD, 0 },
  Package(){0x0009FFFF, 3, INTA, 0 },
  Package(){0x000AFFFF, 0, INTC, 0 },
  Package(){0x000AFFFF, 1, INTD, 0 },
  Package(){0x000AFFFF, 2, INTA, 0 },
  Package(){0x000AFFFF, 3, INTB, 0 },
  Package(){0x000BFFFF, 0, INTD, 0 },
  Package(){0x000BFFFF, 1, INTA, 0 },
  Package(){0x000BFFFF, 2, INTB, 0 },
  Package(){0x000BFFFF, 3, INTC, 0 },
  Package(){0x000CFFFF, 0, INTA, 0 },
  Package(){0x000CFFFF, 1, INTB, 0 },
  Package(){0x000CFFFF, 2, INTC, 0 },
  Package(){0x000CFFFF, 3, INTD, 0 },
  Package(){0x0011FFFF, 0, INTD, 0 },
  Package(){0x0012FFFF, 0, INTC, 0 },
  Package(){0x0012FFFF, 1, INTB, 0 },
  Package(){0x0013FFFF, 0, INTC, 0 },
  Package(){0x0013FFFF, 1, INTB, 0 },
  Package(){0x0016FFFF, 0, INTC, 0 },
  Package(){0x0016FFFF, 1, INTB, 0 },
  Package(){0x0014FFFF, 0, INTA, 0 },
  Package(){0x0014FFFF, 1, INTB, 0 },
  Package(){0x0014FFFF, 2, INTC, 0 },
  Package(){0x0014FFFF, 3, INTD, 0 },
  Package(){0x0015FFFF, 0, INTA, 0 },
  Package(){0x0015FFFF, 1, INTB, 0 },
  Package(){0x0015FFFF, 2, INTC, 0 },
  Package(){0x0015FFFF, 3, INTD, 0 },
 })
 Name(APR0, Package(){
  Package(){0x0001FFFF, 0, 0, 18 },
  Package(){0x0001FFFF, 1, 0, 19 },
  Package(){0x0002FFFF, 0, 0, 18 },
  Package(){0x0003FFFF, 0, 0, 19 },
  Package(){0x0003FFFF, 1, 0, 16 },
  Package(){0x0003FFFF, 2, 0, 17 },
  Package(){0x0003FFFF, 3, 0, 18 },
  Package(){0x0004FFFF, 0, 0, 16 },
  Package(){0x0004FFFF, 1, 0, 17 },
  Package(){0x0004FFFF, 2, 0, 18 },
  Package(){0x0004FFFF, 3, 0, 19 },
  Package(){0x0005FFFF, 0, 0, 17 },
  Package(){0x0005FFFF, 1, 0, 18 },
  Package(){0x0005FFFF, 2, 0, 19 },
  Package(){0x0005FFFF, 3, 0, 16 },
  Package(){0x0006FFFF, 0, 0, 18 },
  Package(){0x0006FFFF, 1, 0, 19 },
  Package(){0x0006FFFF, 2, 0, 16 },
  Package(){0x0006FFFF, 3, 0, 17 },
  Package(){0x0007FFFF, 0, 0, 19 },
  Package(){0x0007FFFF, 1, 0, 16 },
  Package(){0x0007FFFF, 2, 0, 17 },
  Package(){0x0007FFFF, 3, 0, 18 },
  Package(){0x0009FFFF, 0, 0, 17 },
  Package(){0x0009FFFF, 1, 0, 16 },
  Package(){0x0009FFFF, 2, 0, 17 },
  Package(){0x0009FFFF, 3, 0, 18 },
  Package(){0x000AFFFF, 0, 0, 18 },
  Package(){0x000AFFFF, 1, 0, 16 },
  Package(){0x000AFFFF, 2, 0, 17 },
  Package(){0x000AFFFF, 3, 0, 18 },
  Package(){0x0011FFFF, 0, 0, 19 },
  Package(){0x0012FFFF, 0, 0, 18 },
  Package(){0x0012FFFF, 1, 0, 17 },
  Package(){0x0013FFFF, 0, 0, 18 },
  Package(){0x0013FFFF, 1, 0, 17 },
  Package(){0x0016FFFF, 0, 0, 18 },
  Package(){0x0016FFFF, 1, 0, 17 },
  Package(){0x0014FFFF, 0, 0, 16 },
  Package(){0x0014FFFF, 1, 0, 17 },
  Package(){0x0014FFFF, 2, 0, 18 },
  Package(){0x0014FFFF, 3, 0, 19 },
  Package(){0x0015FFFF, 0, 0, 16 },
  Package(){0x0015FFFF, 1, 0, 17 },
  Package(){0x0015FFFF, 2, 0, 18 },
  Package(){0x0015FFFF, 3, 0, 19 },
 })
 Name(PR1, Package(){
  Package(){0x0005FFFF, 0, INTA, 0 },
  Package(){0x0005FFFF, 1, INTB, 0 },
  Package(){0x0005FFFF, 2, INTC, 0 },
  Package(){0x0005FFFF, 3, INTD, 0 },
 })
 Name(APR1, Package(){
  Package(){0x0005FFFF, 0, 0, 18 },
  Package(){0x0005FFFF, 1, 0, 19 },
 })
 Name(PS2, Package(){
  Package(){0x0000FFFF, 0, INTC, 0 },
  Package(){0x0000FFFF, 1, INTD, 0 },
  Package(){0x0000FFFF, 2, INTA, 0 },
  Package(){0x0000FFFF, 3, INTB, 0 },
 })
 Name(APS2, Package(){
  Package(){0x0000FFFF, 0, 0, 18 },
  Package(){0x0000FFFF, 1, 0, 19 },
  Package(){0x0000FFFF, 2, 0, 16 },
  Package(){0x0000FFFF, 3, 0, 17 },
 })
 Name(PS4, Package(){
  Package(){0x0000FFFF, 0, INTA, 0 },
  Package(){0x0000FFFF, 1, INTB, 0 },
  Package(){0x0000FFFF, 2, INTC, 0 },
  Package(){0x0000FFFF, 3, INTD, 0 },
 })
 Name(APS4, Package(){
  Package(){0x0000FFFF, 0, 0, 16 },
  Package(){0x0000FFFF, 1, 0, 17 },
  Package(){0x0000FFFF, 2, 0, 18 },
  Package(){0x0000FFFF, 3, 0, 19 },
 })
 Name(PS5, Package(){
  Package(){0x0000FFFF, 0, INTB, 0 },
  Package(){0x0000FFFF, 1, INTC, 0 },
  Package(){0x0000FFFF, 2, INTD, 0 },
  Package(){0x0000FFFF, 3, INTA, 0 },
 })
 Name(APS5, Package(){
  Package(){0x0000FFFF, 0, 0, 17 },
  Package(){0x0000FFFF, 1, 0, 18 },
  Package(){0x0000FFFF, 2, 0, 19 },
  Package(){0x0000FFFF, 3, 0, 16 },
 })
 Name(PS6, Package(){
  Package(){0x0000FFFF, 0, INTC, 0 },
  Package(){0x0000FFFF, 1, INTD, 0 },
  Package(){0x0000FFFF, 2, INTA, 0 },
  Package(){0x0000FFFF, 3, INTB, 0 },
 })
 Name(APS6, Package(){
  Package(){0x0000FFFF, 0, 0, 18 },
  Package(){0x0000FFFF, 1, 0, 19 },
  Package(){0x0000FFFF, 2, 0, 16 },
  Package(){0x0000FFFF, 3, 0, 17 },
 })
 Name(PS7, Package(){
  Package(){0x0000FFFF, 0, INTD, 0 },
  Package(){0x0000FFFF, 1, INTA, 0 },
  Package(){0x0000FFFF, 2, INTB, 0 },
  Package(){0x0000FFFF, 3, INTC, 0 },
 })
 Name(APS7, Package(){
  Package(){0x0000FFFF, 0, 0, 19 },
  Package(){0x0000FFFF, 1, 0, 16 },
  Package(){0x0000FFFF, 2, 0, 17 },
  Package(){0x0000FFFF, 3, 0, 18 },
 })
 Name(PS9, Package(){
  Package(){0x0000FFFF, 0, INTD, 0 },
  Package(){0x0000FFFF, 1, INTA, 0 },
  Package(){0x0000FFFF, 2, INTB, 0 },
  Package(){0x0000FFFF, 3, INTC, 0 },
 })
 Name(APS9, Package(){
  Package(){0x0000FFFF, 0, 0, 17 },
  Package(){0x0000FFFF, 1, 0, 18 },
  Package(){0x0000FFFF, 2, 0, 19 },
  Package(){0x0000FFFF, 3, 0, 16 },
 })
 Name(PSa, Package(){
  Package(){0x0000FFFF, 0, INTD, 0 },
  Package(){0x0000FFFF, 1, INTA, 0 },
  Package(){0x0000FFFF, 2, INTB, 0 },
  Package(){0x0000FFFF, 3, INTC, 0 },
 })
 Name(APSa, Package(){
  Package(){0x0000FFFF, 0, 0, 18 },
  Package(){0x0000FFFF, 1, 0, 19 },
  Package(){0x0000FFFF, 2, 0, 16 },
  Package(){0x0000FFFF, 3, 0, 17 },
 })
 Name(PE0, Package(){
  Package(){0x0000FFFF, 0, INTA, 0 },
  Package(){0x0000FFFF, 1, INTB, 0 },
  Package(){0x0000FFFF, 2, INTC, 0 },
  Package(){0x0000FFFF, 3, INTD, 0 },
 })
 Name(APE0, Package(){
  Package(){0x0000FFFF, 0, 0, 16 },
  Package(){0x0000FFFF, 1, 0, 17 },
  Package(){0x0000FFFF, 2, 0, 18 },
  Package(){0x0000FFFF, 3, 0, 19 },
 })
 Name(PE1, Package(){
  Package(){0x0000FFFF, 0, INTB, 0 },
  Package(){0x0000FFFF, 1, INTC, 0 },
  Package(){0x0000FFFF, 2, INTD, 0 },
  Package(){0x0000FFFF, 3, INTA, 0 },
 })
 Name(APE1, Package(){
  Package(){0x0000FFFF, 0, 0, 17 },
  Package(){0x0000FFFF, 1, 0, 18 },
  Package(){0x0000FFFF, 2, 0, 19 },
  Package(){0x0000FFFF, 3, 0, 16 },
 })
 Name(PE2, Package(){
  Package(){0x0000FFFF, 0, INTC, 0 },
  Package(){0x0000FFFF, 1, INTD, 0 },
  Package(){0x0000FFFF, 2, INTA, 0 },
  Package(){0x0000FFFF, 3, INTB, 0 },
 })
 Name(APE2, Package(){
  Package(){0x0000FFFF, 0, 0, 18 },
  Package(){0x0000FFFF, 1, 0, 19 },
  Package(){0x0000FFFF, 2, 0, 16 },
  Package(){0x0000FFFF, 3, 0, 17 },
 })
 Name(PE3, Package(){
  Package(){0x0000FFFF, 0, INTD, 0 },
  Package(){0x0000FFFF, 1, INTA, 0 },
  Package(){0x0000FFFF, 2, INTB, 0 },
  Package(){0x0000FFFF, 3, INTC, 0 },
 })
 Name(APE3, Package(){
  Package(){0x0000FFFF, 0, 0, 19 },
  Package(){0x0000FFFF, 1, 0, 16 },
  Package(){0x0000FFFF, 2, 0, 17 },
  Package(){0x0000FFFF, 3, 0, 18 },
 })
 Name(PCIB, Package(){
  Package(){0x0005FFFF, 0, 0, 0x14 },
  Package(){0x0005FFFF, 1, 0, 0x15 },
  Package(){0x0005FFFF, 2, 0, 0x16 },
  Package(){0x0005FFFF, 3, 0, 0x17 },
  Package(){0x0006FFFF, 0, 0, 0x15 },
  Package(){0x0006FFFF, 1, 0, 0x16 },
  Package(){0x0006FFFF, 2, 0, 0x17 },
  Package(){0x0006FFFF, 3, 0, 0x14 },
  Package(){0x0007FFFF, 0, 0, 0x16 },
  Package(){0x0007FFFF, 1, 0, 0x17 },
  Package(){0x0007FFFF, 2, 0, 0x14 },
  Package(){0x0007FFFF, 3, 0, 0x15 },
 })
}
 Scope(\_SB) {
Method(MIN, 2)
{
 if (LLess(Arg0, Arg1)) {
  Return(Arg0)
 } else {
  Return(Arg1)
 }
}
Method(SLEN, 1)
{
 Store(Arg0, Local0)
 Return(Sizeof(Local0))
}
Method(S2BF, 1, Serialized)
{
 Add(SLEN(Arg0), One, Local0)
 Name(BUFF, Buffer(Local0) {})
 Store(Arg0, BUFF)
 Return(BUFF)
}
Method(SCMP, 2)
{
 Store(S2BF(Arg0), Local0)
 Store(S2BF(Arg1), Local1)
 Store(Zero, Local4)
 Store(SLEN(Arg0), Local5)
 Store(SLEN(Arg1), Local6)
 Store(MIN(Local5, Local6), Local7)
 While(LLess(Local4, Local7)) {
  Store(Derefof(Index(Local0, Local4)), Local2)
  Store(Derefof(Index(Local1, Local4)), Local3)
  if (LGreater(Local2, Local3)) {
   Return(One)
  } else {
   if (LLess(Local2, Local3)) {
    Return(Ones)
   }
  }
  Increment(Local4)
 }
 if (LLess(Local4, Local5)) {
  Return(One)
 } else {
  if (LLess(Local4, Local6)) {
   Return(Ones)
  } else {
   Return(Zero)
  }
 }
}
Method(WCMP, 2)
{
 Store(S2BF(Arg0), Local0)
 Store(S2BF(Arg1), Local1)
 if (LLess(SLEN(Arg0), SLEN(Arg1))) {
  Return(0)
 }
 Store(Zero, Local2)
 Store(SLEN(Arg1), Local3)
 While(LLess(Local2, Local3)) {
  if (LNotEqual(Derefof(Index(Local0, Local2)),
   Derefof(Index(Local1, Local2)))) {
   Return(0)
  }
  Increment(Local2)
 }
 Return(One)
}
Method(I2BM, 1)
{
 Store(0, Local0)
 if (LNotEqual(ARG0, 0)) {
  Store(1, Local1)
  ShiftLeft(Local1, ARG0, Local0)
 }
 Return(Local0)
}
  Device(PCI0) {
External (TOM1)
External (TOM2)
Name(_HID, EISAID("PNP0A08"))
Name(_CID, EISAID("PNP0A03"))
Name(_ADR, 0x00180000)
Device(AMRT) {
 Name(_ADR, 0x00000000)
}
Device(AGPB) {
 Name(_ADR, 0x00010000)
 Name(_PRW, Package() {0x18, 4})
 Method(_PRT,0) {
  If(PMOD){ Return(APR1) }
  Return (PR1)
 }
}
Device(HDMI) {
 Name(_ADR, 0x00010001)
 Name(_PRW, Package() {0x18, 4})
 Method(_PRT,0) {
  If(PMOD){ Return(APR1) }
  Return (PR1)
 }
}
Device(PBR4) {
 Name(_ADR, 0x00040000)
 Name(_PRW, Package() {0x18, 4})
 Method(_PRT,0) {
  If(PMOD){ Return(APS4) }
  Return (PS4)
 }
}
Device(PBR5) {
 Name(_ADR, 0x00050000)
 Name(_PRW, Package() {0x18, 4})
 Method(_PRT,0) {
  If(PMOD){ Return(APS5) }
  Return (PS5)
 }
}
Device(PBR6) {
 Name(_ADR, 0x00060000)
 Name(_PRW, Package() {0x18, 4})
 Method(_PRT,0) {
  If(PMOD){ Return(APS6) }
  Return (PS6)
 }
}
Device(PBR7) {
 Name(_ADR, 0x00070000)
 Name(_PRW, Package() {0x18, 4})
 Method(_PRT,0) {
  If(PMOD){ Return(APS7) }
  Return (PS7)
 }
}
Device(PE20) {
 Name(_ADR, 0x00150000)
 Name(_PRW, Package() {0x18, 4})
 Method(_PRT,0) {
  If(PMOD){ Return(APE0) }
  Return (PE0)
 }
}
Device(PE21) {
 Name(_ADR, 0x00150001)
 Name(_PRW, Package() {0x18, 4})
 Method(_PRT,0) {
  If(PMOD){ Return(APE1) }
  Return (PE1)
 }
}
Device(PE22) {
 Name(_ADR, 0x00150002)
 Name(_PRW, Package() {0x18, 4})
 Method(_PRT,0) {
  If(PMOD){ Return(APE2) }
  Return (APE2)
 }
}
Device(PE23) {
 Name(_ADR, 0x00150003)
 Name(_PRW, Package() {0x18, 4})
 Method(_PRT,0) {
  If(PMOD){ Return(APE3) }
  Return (PE3)
 }
}
Method(_OSC,4)
{
 CreateDWordField(Arg3,0,CDW1)
 CreateDWordField(Arg3,4,CDW2)
 CreateDWordField(Arg3,8,CDW3)
 If(LEqual(Arg0,ToUUID("33DB4D5B-1FF7-401C-9657-7441C03DD766")))
 {
  Return (Arg3)
 } Else {
  Or(CDW1,4,CDW1)
  Return(Arg3)
 }
}
Method(_BBN, 0) {
 Return(0)
}
Method(_STA, 0) {
 Return(0x0B)
}
Method(_PRT,0) {
 If(PMOD){ Return(APR0) }
 Return (PR0)
}
Scope(\) {
 OperationRegion(PRQM, SystemIO, 0x00000C00, 0x00000002)
  Field(PRQM, ByteAcc, NoLock, Preserve) {
  PRQI, 0x00000008,
  PRQD, 0x00000008,
 }
 IndexField(PRQI, PRQD, ByteAcc, NoLock, Preserve) {
  PIRA, 0x00000008,
  PIRB, 0x00000008,
  PIRC, 0x00000008,
  PIRD, 0x00000008,
  PIRE, 0x00000008,
  PIRF, 0x00000008,
  PIRG, 0x00000008,
  PIRH, 0x00000008,
 }
 OperationRegion(PERC, SystemIO, 0x00000C14, 0x00000001)
  Field(PERC, ByteAcc, NoLock, Preserve) {
  SENS, 0x00000001,
  PENS, 0x00000001,
  SENE, 0x00000001,
  PENE, 0x00000001,
 }
}
Scope(\_SB) {
 OperationRegion(PCFG, SystemMemory, PCBA, 0x01000000)
  Field(PCFG, ByteAcc, NoLock, Preserve) {
  Offset(0x00088024),
  STB5, 32,
  Offset(0x00098042),
  PT0D, 1,
  PT1D, 1,
  PT2D, 1,
  PT3D, 1,
  PT4D, 1,
  PT5D, 1,
  PT6D, 1,
  PT7D, 1,
  PT8D, 1,
  PT9D, 1,
  Offset(0x000A0004),
  SBIE, 1,
  SBME, 1,
  Offset(0x000A0008),
  SBRI, 8,
  Offset(0x000A0014),
  SBB1, 32,
  Offset(0x000A0078),
  ,14,
  P92E, 1,
 }
 OperationRegion(SB5, SystemMemory, STB5, 0x1000)
  Field(SB5, AnyAcc, NoLock, Preserve){
  Offset(0x120),
  P0ER, 1,
  , 2,
  P0DQ, 1,
  , 3,
  P0BY, 1,
  Offset(0x128),
  P0DD, 4,
  , 4,
  P0IS, 4,
  Offset(0x12C),
  P0DI, 4,
  Offset(0x130),
  , 16,
  P0PR, 1,
  offset(0x1A0),
  P1ER, 1,
  , 2,
  P1DQ, 1,
  , 3,
  P1BY, 1,
  Offset(0x1A8),
  P1DD, 4,
  , 4,
  P1IS, 4,
  Offset(0x1AC),
  P1DI, 4,
  Offset(0x1B0),
  , 16,
  P1PR, 1,
  Offset(0x220),
  P2ER, 1,
  , 2,
  P2DQ, 1,
  , 3,
  P2BY, 1,
  Offset(0x228),
  P2DD, 4,
  , 4,
  P2IS, 4,
  Offset(0x22C),
  P2DI, 4,
  Offset(0x230),
  , 16,
  P2PR, 1,
  Offset(0x2A0),
  P3ER, 1,
  , 2,
  P3DQ, 1,
  , 3,
  P3BY, 1,
  Offset(0x2A8),
  P3DD, 4,
  , 4,
  P3IS, 4,
  Offset(0x2AC),
  P3DI, 4,
  Offset(0x2B0),
  , 16,
  P3PR, 1,
 }
  Method(_PIC, 0x01, NotSerialized)
  {
   If (Arg0)
   {
    \_SB.CIRQ()
   }
   Store(Arg0, PMOD)
  }
  Method(CIRQ, 0x00, NotSerialized){
   Store(0, PIRA)
   Store(0, PIRB)
   Store(0, PIRC)
   Store(0, PIRD)
   Store(0, PIRE)
   Store(0, PIRF)
   Store(0, PIRG)
   Store(0, PIRH)
  }
  Name(IRQB, ResourceTemplate(){
   IRQ(Level,ActiveLow,Shared){15}
  })
  Name(IRQP, ResourceTemplate(){
   IRQ(Level,ActiveLow,Exclusive){3, 4, 5, 7, 10, 11, 12, 15}
  })
  Name(PITF, ResourceTemplate(){
   IRQ(Level,ActiveLow,Exclusive){9}
  })
  Device(INTA) {
   Name(_HID, EISAID("PNP0C0F"))
   Name(_UID, 1)
   Method(_STA, 0) {
    if (PIRA) {
     Return(0x0B)
    } else {
     Return(0x09)
    }
   }
   Method(_DIS ,0) {
    Store(0, PIRA)
   }
   Method(_PRS ,0) {
    Return(IRQP)
   }
   Method(_CRS ,0) {
    CreateWordField(IRQB, 0x1, IRQN)
    ShiftLeft(1, PIRA, IRQN)
    Return(IRQB)
   }
   Method(_SRS, 1) {
    CreateWordField(ARG0, 1, IRQM)
    FindSetRightBit(IRQM, Local0)
    if (Local0) {
     Decrement(Local0)
    }
    Store(Local0, PIRA)
   }
  }
  Device(INTB) {
   Name(_HID, EISAID("PNP0C0F"))
   Name(_UID, 2)
   Method(_STA, 0) {
    if (PIRB) {
     Return(0x0B)
    } else {
     Return(0x09)
    }
   }
   Method(_DIS ,0) {
    Store(0, PIRB)
   }
   Method(_PRS ,0) {
    Return(IRQP)
   }
   Method(_CRS ,0) {
    CreateWordField(IRQB, 0x1, IRQN)
    ShiftLeft(1, PIRB, IRQN)
    Return(IRQB)
   }
   Method(_SRS, 1) {
    CreateWordField(ARG0, 1, IRQM)
    FindSetRightBit(IRQM, Local0)
    if (Local0) {
     Decrement(Local0)
    }
    Store(Local0, PIRB)
   }
  }
  Device(INTC) {
   Name(_HID, EISAID("PNP0C0F"))
   Name(_UID, 3)
   Method(_STA, 0) {
    if (PIRC) {
     Return(0x0B)
    } else {
     Return(0x09)
    }
   }
   Method(_DIS ,0) {
    Store(0, PIRC)
   }
   Method(_PRS ,0) {
    Return(IRQP)
   }
   Method(_CRS ,0) {
    CreateWordField(IRQB, 0x1, IRQN)
    ShiftLeft(1, PIRC, IRQN)
    Return(IRQB)
   }
   Method(_SRS, 1) {
    CreateWordField(ARG0, 1, IRQM)
    FindSetRightBit(IRQM, Local0)
    if (Local0) {
     Decrement(Local0)
    }
    Store(Local0, PIRC)
   }
  }
  Device(INTD) {
   Name(_HID, EISAID("PNP0C0F"))
   Name(_UID, 4)
   Method(_STA, 0) {
    if (PIRD) {
     Return(0x0B)
    } else {
     Return(0x09)
    }
   }
   Method(_DIS ,0) {
    Store(0, PIRD)
   }
   Method(_PRS ,0) {
    Return(IRQP)
   }
   Method(_CRS ,0) {
    CreateWordField(IRQB, 0x1, IRQN)
    ShiftLeft(1, PIRD, IRQN)
    Return(IRQB)
   }
   Method(_SRS, 1) {
    CreateWordField(ARG0, 1, IRQM)
    FindSetRightBit(IRQM, Local0)
    if (Local0) {
     Decrement(Local0)
    }
    Store(Local0, PIRD)
   }
  }
  Device(INTE) {
   Name(_HID, EISAID("PNP0C0F"))
   Name(_UID, 5)
   Method(_STA, 0) {
    if (PIRE) {
     Return(0x0B)
    } else {
     Return(0x09)
    }
   }
   Method(_DIS ,0) {
    Store(0, PIRE)
   }
   Method(_PRS ,0) {
    Return(IRQP)
   }
   Method(_CRS ,0) {
    CreateWordField(IRQB, 0x1, IRQN)
    ShiftLeft(1, PIRE, IRQN)
    Return(IRQB)
   }
   Method(_SRS, 1) {
    CreateWordField(ARG0, 1, IRQM)
    FindSetRightBit(IRQM, Local0)
    if (Local0) {
     Decrement(Local0)
    }
    Store(Local0, PIRE)
   }
  }
  Device(INTF) {
   Name(_HID, EISAID("PNP0C0F"))
   Name(_UID, 6)
   Method(_STA, 0) {
    if (PIRF) {
     Return(0x0B)
    } else {
     Return(0x09)
    }
   }
   Method(_DIS ,0) {
    Store(0, PIRF)
   }
   Method(_PRS ,0) {
    Return(PITF)
   }
   Method(_CRS ,0) {
    CreateWordField(IRQB, 0x1, IRQN)
    ShiftLeft(1, PIRF, IRQN)
    Return(IRQB)
   }
   Method(_SRS, 1) {
    CreateWordField(ARG0, 1, IRQM)
    FindSetRightBit(IRQM, Local0)
    if (Local0) {
     Decrement(Local0)
    }
    Store(Local0, PIRF)
   }
  }
  Device(INTG) {
   Name(_HID, EISAID("PNP0C0F"))
   Name(_UID, 7)
   Method(_STA, 0) {
    if (PIRG) {
     Return(0x0B)
    } else {
     Return(0x09)
    }
   }
   Method(_DIS ,0) {
    Store(0, PIRG)
   }
   Method(_PRS ,0) {
    Return(IRQP)
   }
   Method(_CRS ,0) {
    CreateWordField(IRQB, 0x1, IRQN)
    ShiftLeft(1, PIRG, IRQN)
    Return(IRQB)
   }
   Method(_SRS, 1) {
    CreateWordField(ARG0, 1, IRQM)
    FindSetRightBit(IRQM, Local0)
    if (Local0) {
     Decrement(Local0)
    }
    Store(Local0, PIRG)
   }
  }
  Device(INTH) {
   Name(_HID, EISAID("PNP0C0F"))
   Name(_UID, 8)
   Method(_STA, 0) {
    if (PIRH) {
     Return(0x0B)
    } else {
     Return(0x09)
    }
   }
   Method(_DIS ,0) {
    Store(0, PIRH)
   }
   Method(_PRS ,0) {
    Return(IRQP)
   }
   Method(_CRS ,0) {
    CreateWordField(IRQB, 0x1, IRQN)
    ShiftLeft(1, PIRH, IRQN)
    Return(IRQB)
   }
   Method(_SRS, 1) {
    CreateWordField(ARG0, 1, IRQM)
    FindSetRightBit(IRQM, Local0)
    if (Local0) {
     Decrement(Local0)
    }
    Store(Local0, PIRH)
   }
  }
 }
Device(PIBR) {
 Name(_ADR, 0x00140004)
 Name(_PRW, Package() {0x18, 4})
 Method(_PRT, 0) {
  Return (PCIB)
 }
}
Device(STCR) {
 Name(_ADR, 0x00110000)
Name(STTM, Buffer(20) {
 0x78, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00,
 0x78, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00,
 0x1f, 0x00, 0x00, 0x00
})
Method(_INI) {
 \_GPE._L1F()
}
Device(PMRY)
{
 Name(_ADR, 0)
 Method(_GTM, 0x0, NotSerialized) {
  Return(STTM)
 }
 Method(_STM, 0x3, NotSerialized) {}
 Device(PMST) {
  Name(_ADR, 0)
  Method(_STA,0) {
   if (LGreater(P0IS,0)) {
    return (0x0F)
   }
   else {
    return (0x00)
   }
  }
 }
 Device(PSLA)
 {
  Name(_ADR, 1)
  Method(_STA,0) {
   if (LGreater(P1IS,0)) {
    return (0x0F)
   }
   else {
    return (0x00)
   }
  }
 }
}
Device(SEDY)
{
 Name(_ADR, 1)
 Method(_GTM, 0x0, NotSerialized) {
  Return(STTM)
 }
 Method(_STM, 0x3, NotSerialized) {}
 Device(SMST)
 {
  Name(_ADR, 0)
  Method(_STA,0) {
   if (LGreater(P2IS,0)) {
    return (0x0F)
   }
   else {
    return (0x00)
   }
  }
 }
 Device(SSLA)
 {
  Name(_ADR, 1)
  Method(_STA,0) {
   if (LGreater(P3IS,0)) {
    return (0x0F)
   }
   else {
    return (0x00)
   }
  }
 }
}
Scope(\_GPE) {
 Method(_L1F,0x0,NotSerialized) {
  if (\_SB.P0PR) {
   if (LGreater(\_SB.P0IS,0)) {
    sleep(32)
   }
   Notify(\_SB.PCI0.STCR.PMRY.PMST, 0x01)
   store(one, \_SB.P0PR)
  }
  if (\_SB.P1PR) {
   if (LGreater(\_SB.P1IS,0)) {
    sleep(32)
   }
   Notify(\_SB.PCI0.STCR.PMRY.PSLA, 0x01)
   store(one, \_SB.P1PR)
  }
  if (\_SB.P2PR) {
   if (LGreater(\_SB.P2IS,0)) {
    sleep(32)
   }
   Notify(\_SB.PCI0.STCR.SEDY.SMST, 0x01)
   store(one, \_SB.P2PR)
  }
  if (\_SB.P3PR) {
   if (LGreater(\_SB.P3IS,0)) {
    sleep(32)
   }
   Notify(\_SB.PCI0.STCR.SEDY.SSLA, 0x01)
   store(one, \_SB.P3PR)
  }
 }
}
}
Device(UOH1) {
 Name(_ADR, 0x00120000)
 Name(_PRW, Package() {0x0B, 3})
}
Device(UOH2) {
 Name(_ADR, 0x00120002)
 Name(_PRW, Package() {0x0B, 3})
}
Device(UOH3) {
 Name(_ADR, 0x00130000)
 Name(_PRW, Package() {0x0B, 3})
}
Device(UOH4) {
 Name(_ADR, 0x00130002)
 Name(_PRW, Package() {0x0B, 3})
}
Device(UOH5) {
 Name(_ADR, 0x00160000)
 Name(_PRW, Package() {0x0B, 3})
}
Device(UOH6) {
 Name(_ADR, 0x00160002)
 Name(_PRW, Package() {0x0B, 3})
}
Device(UEH1) {
 Name(_ADR, 0x00140005)
 Name(_PRW, Package() {0x0B, 3})
}
Device(SBUS) {
 Name(_ADR, 0x00140000)
}
Device(AZHD) {
 Name(_ADR, 0x00140002)
 OperationRegion(AZPD, PCI_Config, 0x00, 0x100)
  Field(AZPD, AnyAcc, NoLock, Preserve) {
  offset (0x42),
  NSDI, 1,
  NSDO, 1,
  NSEN, 1,
  offset (0x44),
  IPCR, 4,
  offset (0x54),
  PWST, 2,
  , 6,
  PMEB, 1,
  , 6,
  PMST, 1,
  offset (0x62),
  MMCR, 1,
  offset (0x64),
  MMLA, 32,
  offset (0x68),
  MMHA, 32,
  offset (0x6C),
  MMDT, 16,
 }
}
Device(LIBR) {
 Name(_ADR, 0x00140003)
 Device(RTC0) {
  Name(_HID, EISAID("PNP0B00"))
  Name(_CRS, ResourceTemplate() {
   IRQNoFlags(){8}
   IO(Decode16,0x0070, 0x0070, 0, 2)
  })
 }
 Device(TMR) {
  Name(_HID,EISAID("PNP0100"))
  Name(_CRS, ResourceTemplate() {
   IRQNoFlags(){0}
   IO(Decode16, 0x0040, 0x0040, 0, 4)
  })
 }
 Device(SPKR) {
  Name(_HID,EISAID("PNP0800"))
  Name(_CRS, ResourceTemplate() {
   IO(Decode16, 0x0061, 0x0061, 0, 1)
  })
 }
 Device(PIC) {
  Name(_HID,EISAID("PNP0000"))
  Name(_CRS, ResourceTemplate() {
   IRQNoFlags(){2}
   IO(Decode16,0x0020, 0x0020, 0, 2)
   IO(Decode16,0x00A0, 0x00A0, 0, 2)
  })
 }
 Device(MAD) {
  Name(_HID,EISAID("PNP0200"))
  Name(_CRS, ResourceTemplate() {
   DMA(Compatibility,BusMaster,Transfer8){4}
   IO(Decode16, 0x0000, 0x0000, 0x10, 0x10)
   IO(Decode16, 0x0081, 0x0081, 0x01, 0x03)
   IO(Decode16, 0x0087, 0x0087, 0x01, 0x01)
   IO(Decode16, 0x0089, 0x0089, 0x01, 0x03)
   IO(Decode16, 0x008F, 0x008F, 0x01, 0x01)
   IO(Decode16, 0x00C0, 0x00C0, 0x10, 0x20)
  })
 }
 Device(COPR) {
  Name(_HID,EISAID("PNP0C04"))
  Name(_CRS, ResourceTemplate() {
   IO(Decode16, 0x00F0, 0x00F0, 0, 0x10)
   IRQNoFlags(){13}
  })
 }
}
Device(HPBR) {
 Name(_ADR, 0x00140004)
}
Device(ACAD) {
 Name(_ADR, 0x00140005)
}
Device(ACMD) {
 Name(_ADR, 0x00140006)
}
Name(CRES, ResourceTemplate() {
 WordBusNumber (ResourceProducer, MinFixed, MaxFixed, PosDecode,
  0x0000,
  0x0000,
  0x00FF,
  0x0000,
  0x0100,
  ,, PSB0)
 IO(Decode16, 0x0CF8, 0x0CF8, 1, 8)
 WORDIO(ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
  0x0000,
  0x0000,
  0x0CF7,
  0x0000,
  0x0CF8
 )
 WORDIO(ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
  0x0000,
  0x0D00,
  0xFFFF,
  0x0000,
  0xF300
 )
 Memory32Fixed(READONLY, 0x000A0000, 0x00020000, VGAM)
 Memory32Fixed(ReadOnly, 0x00000000, 0x00000000, MMIO)
})
Method(_CRS, 0) {
 CreateDWordField(CRES, ^MMIO._BAS, MM1B)
 CreateDWordField(CRES, ^MMIO._LEN, MM1L)
 Store(TOM1, MM1B)
 ShiftLeft(0x10000000, 4, Local0)
 Subtract(Local0, TOM1, Local0)
 Store(Local0, MM1L)
 Return(CRES)
}
Method(_INI, 0) {
 OSFL()
}
Scope(\){
 OperationRegion(CMT, SystemIO, 0x00000C50, 0x00000002)
  Field(CMT, ByteAcc, NoLock, Preserve) {
  CMTI, 8,
  G64E, 1,
  G64O, 1,
  G32O, 2,
  , 2,
  GPSL, 2,
 }
 OperationRegion(GPT, SystemIO, 0x00000C52, 0x00000001)
  Field(GPT, ByteAcc, NoLock, Preserve) {
  GPB0,1,
  GPB1,1,
  GPB2,1,
  GPB3,1,
  GPB4,1,
  GPB5,1,
  GPB6,1,
  GPB7,1,
 }
 OperationRegion(FRE, SystemIO, 0x00000C6F, 0x00000001)
  Field(FRE, ByteAcc, NoLock, Preserve) {
  , 0x00000006,
  FLRE, 0x00000001,
 }
 OperationRegion(PM2R, SystemIO, 0x00000CD0, 0x00000002)
  Field(PM2R, ByteAcc, NoLock, Preserve) {
  PM2I, 0x00000008,
  PM2D, 0x00000008,
 }
 OperationRegion(PIOR, SystemIO, 0x00000CD6, 0x00000002)
  Field(PIOR, ByteAcc, NoLock, Preserve) {
  PIOI, 0x00000008,
  PIOD, 0x00000008,
 }
 IndexField (PIOI, PIOD, ByteAcc, NoLock, Preserve) {
  Offset(0x00),
  , 1,
  T1EE, 1,
  T2EE, 1,
  Offset(0x01),
  , 1,
  T1E, 1,
  T2E, 1,
  Offset(0x04),
  , 7,
  SSEN, 1,
  Offset(0x07),
  , 7,
  CSSM, 1,
  Offset(0x10),
  , 6,
  PWDE, 1,
  Offset(0x1C),
  , 3,
  MKME, 1,
  IO3E, 1,
  IO2E, 1,
  IO1E, 1,
  IO0E, 1,
  Offset(0x1D),
  , 3,
  MKMS, 1,
  IO3S, 1,
  IO2S, 1,
  IO1S, 1,
  IO0S,1,
  Offset(0x20),
  APEB, 16,
  Offset(0x36),
  , 6,
  ELC6, 1,
  ELC7, 1,
  Offset(0x37),
  , 3,
  PLC0, 1,
  PLC1, 1,
  PLC2, 1,
  PLC3, 1,
  PLC8, 1,
  Offset(0x38),
  , 1,
   PLC4, 1,
   PLC5, 1,
  , 1,
   PLC6, 1,
   PLC7, 1,
  Offset(0x3B),
  GP0S, 1,
  GM4S, 1,
  GM5S, 1,
  APS, 1,
  GM6S, 1,
  GM7S, 1,
  GP2S, 1,
  STSS, 1,
  Offset(0x55),
  SPRE, 1,
  , 1,
  , 1,
  PNAT, 1,
  PWMK, 1,
  PWNS, 1,
  Offset(0x65),
  , 4,
  URRE, 1,
  Offset(0x68),
  , 3,
  TMTE, 1,
  , 1,
  Offset(0x92),
  , 7,
  E7IS, 1,
  Offset(0x96),
  G8IS, 1,
  G9IS, 1,
  Offset(0x9A),
  ,7,
  HPDE, 1,
  Offset(0xA8),
  IO4E, 1,
  IO5E, 1,
  IO6E, 1,
  IO7E, 1,
  Offset(0xA9),
  IO4S, 1,
  IO5S, 1,
  IO6S, 1,
  IO7S, 1,
 }
 OperationRegion(P1EB, SystemIO, APEB, 0x04)
  Field(P1EB, ByteAcc, NoLock, Preserve) {
  TMST, 1,
  , 3,
  BMST, 1,
  GBST, 1,
  Offset(0x01),
  PBST, 1,
  , 1,
  RTST, 1,
  , 3,
  PWST, 1,
  SPWS, 1,
  Offset(0x02),
  TMEN, 1,
  , 4,
  GBEN, 1,
  Offset(0x03),
  PBEN, 1,
  , 1,
  RTEN, 1,
  , 3,
  PWDA, 1,
 }
}
Scope(\_SB) {
 Device(PWRB) {
  Name(_HID, EISAID("PNP0C0C"))
  Name(_UID, 0xAA)
  Name(_PRW, Package () {3, 0x04})
  Name(_STA, 0x0B)
 }
}
  }
 }
Name(\_S0, Package () {0x00, 0x00, 0x00, 0x00} )
If (LAnd(SSFG, 0x01)) {
 Name(\_S1, Package () {0x01, 0x01, 0x00, 0x00} )
}
If (LAnd(SSFG, 0x04)) {
 Name(\_S3, Package () {0x03, 0x03, 0x00, 0x00} )
}
If (LAnd(SSFG, 0x08)) {
 Name(\_S4, Package () {0x04, 0x04, 0x00, 0x00} )
}
Name(\_S5, Package () {0x05, 0x05, 0x00, 0x00} )
Name(\_SB.CSPS ,0)
Name(CSMS, 0)
Name(WKST,Package(){Zero, Zero})
Method(\_PTS, 1) {
 if (LEqual(Arg0,3)){
  Store(0,URRE)
 }
 Store(0, Index(WKST,0))
 Store(0, Index(WKST,1))
}
Method(\_BFS, 1) {
}
Method(\_WAK, 1) {
 Store(1,HPDE)
 if (LEqual(Arg0,3)){
  Store(1,URRE)
 }
 Store(PWST, PWST)
 Return(WKST)
}
Scope(\_GPE) {
 Method(_L03) {
  Notify(\_SB.PWRB, 0x02)
 }
 Method(_L08) {
 }
 Method(_L09) {
 }
 Method(_L0B) {
  Notify(\_SB.PCI0.UOH1, 0x02)
  Notify(\_SB.PCI0.UOH2, 0x02)
  Notify(\_SB.PCI0.UOH3, 0x02)
  Notify(\_SB.PCI0.UOH4, 0x02)
  Notify(\_SB.PCI0.UOH5, 0x02)
  Notify(\_SB.PCI0.UOH6, 0x02)
  Notify(\_SB.PCI0.UEH1, 0x02)
  Notify(\_SB.PWRB, 0x02)
 }
 Method(_L10) {
 }
 Method(_L11) {
 }
 Method(_L18) {
  Notify(\_SB.PCI0.PBR4, 0x02)
  Notify(\_SB.PCI0.PBR5, 0x02)
  Notify(\_SB.PCI0.PBR6, 0x02)
  Notify(\_SB.PCI0.PBR7, 0x02)
  Notify(\_SB.PWRB, 0x02)
 }
 Method(_L1B) {
  Notify(\_SB.PCI0.AZHD, 0x02)
  Notify(\_SB.PWRB, 0x02)
 }
}
Name(UOM0, 0)
Name(UOM1, 2)
Name(UOM2, 0)
Name(UOM3, 7)
Name(UOM4, 2)
Name(UOM5, 2)
Name(UOM6, 6)
Name(UOM7, 2)
Name(UOM8, 6)
Name(UOM9, 6)
Method(UCOC, 0) {
 Sleep(20)
     Store(0x13,CMTI)
 Store(0,GPSL)
}
If(LLessEqual(UOM0,9)) {
 Scope (\_GPE) {
  Method (_L13) {
   UCOC()
   if(LEqual(GPB0,PLC0)) {
    Not(PLC0,PLC0)
    Store(PLC0, \_SB.PT0D)
   }
  }
 }
}
If (LLessEqual(UOM1,9)) {
 Scope (\_GPE) {
  Method (_L14) {
   UCOC()
   if (LEqual(GPB1,PLC1)) {
    Not(PLC1,PLC1)
    Store(PLC1, \_SB.PT1D)
   }
  }
 }
}
If (LLessEqual(UOM2,9)) {
 Scope (\_GPE) {
  Method (_L15) {
   UCOC()
   if (LEqual(GPB2,PLC2)) {
    Not(PLC2,PLC2)
    Store(PLC2, \_SB.PT2D)
   }
  }
 }
}
If (LLessEqual(UOM3,9)) {
 Scope (\_GPE) {
  Method (_L16) {
   UCOC()
   if (LEqual(GPB3,PLC3)) {
    Not(PLC3,PLC3)
    Store(PLC3, \_SB.PT3D)
   }
  }
 }
}
If (LLessEqual(UOM4,9)) {
 Scope (\_GPE) {
  Method (_L19) {
   UCOC()
   if (LEqual(GPB4,PLC4)) {
    Not(PLC4,PLC4)
    Store(PLC4, \_SB.PT4D)
   }
  }
 }
}
If (LLessEqual(UOM5,9)) {
 Scope (\_GPE) {
  Method (_L1A) {
   UCOC()
   if (LEqual(GPB5,PLC5)) {
    Not(PLC5,PLC5)
    Store(PLC5, \_SB.PT5D)
   }
  }
 }
}
If (LLessEqual(UOM6,9)) {
 Scope (\_GPE) {
  Method (_L06) {
   UCOC()
   if (LEqual(GPB6,PLC6)) {
    Not(PLC6,PLC6)
    Store(PLC6, \_SB.PT6D)
   }
  }
 }
}
If (LLessEqual(UOM7,9)) {
  Scope (\_GPE) {
  Method (_L07) {
   UCOC()
   if (LEqual(GPB7,PLC7)) {
    Not(PLC7,PLC7)
    Store(PLC7, \_SB.PT7D)
   }
  }
 }
}
If (LLessEqual(UOM8,9)) {
 Scope (\_GPE) {
  Method (_L17) {
   if (LEqual(G8IS,PLC8)) {
    Not(PLC8,PLC8)
    Store(PLC8, \_SB.PT8D)
   }
  }
 }
}
If (LLessEqual(UOM9,9)) {
 Scope (\_GPE) {
  Method (_L0E) {
   if (LEqual(G9IS,0)) {
   Store(1,\_SB.PT9D)
   }
  }
 }
}
Mutex (SBX0, 0x00)
OperationRegion (SMB0, SystemIO, 0xB00, 0x0C)
 Field (SMB0, ByteAcc, NoLock, Preserve) {
  HSTS, 8,
  SSTS, 8,
  HCNT, 8,
  HCMD, 8,
  HADD, 8,
  DAT0, 8,
  DAT1, 8,
  BLKD, 8,
  SCNT, 8,
  SCMD, 8,
  SEVT, 8,
  SDAT, 8
}
Method (WCLR, 0, NotSerialized) {
 Store (0x1E, HSTS)
 Store (0xFA, Local0)
 While (LAnd (LNotEqual (And (HSTS, 0x1E), Zero), LGreater (Local0, Zero))) {
  Stall (0x64)
  Decrement (Local0)
 }
 Return (Local0)
}
Method (SWTC, 1, NotSerialized) {
 Store (Arg0, Local0)
 Store (0x07, Local2)
 Store (One, Local1)
 While (LEqual (Local1, One)) {
  Store (And (HSTS, 0x1E), Local3)
  If (LNotEqual (Local3, Zero)) {
   If (LEqual (Local3, 0x02)) {
    Store (Zero, Local2)
   }
   Store (Zero, Local1)
  }
  Else {
   If (LLess (Local0, 0x0A)) {
    Store (0x10, Local2)
    Store (Zero, Local1)
   }
   Else {
    Sleep (0x0A)
    Subtract (Local0, 0x0A, Local0)
   }
  }
 }
 Return (Local2)
}
Method (SMBR, 3, NotSerialized) {
 Store (0x07, Local0)
 If (LEqual (Acquire (SBX0, 0xFFFF), Zero)) {
  Store (WCLR (), Local0)
  If (LEqual (Local0, Zero)) {
   Release (SBX0)
   Return (0x0)
  }
  Store (0x1F, HSTS)
  Store (Or (ShiftLeft (Arg1, One), One), HADD)
  Store (Arg2, HCMD)
  If (LEqual (Arg0, 0x07)) {
   Store (0x48, HCNT)
  }
  Store (SWTC (0x03E8), Local1)
  If (LEqual (Local1, Zero)) {
   If (LEqual (Arg0, 0x07)) {
    Store (DAT0, Local0)
   }
  }
  Else {
   Store (Local1, Local0)
  }
  Release (SBX0)
 }
 Return (Local0)
}
Scope(\_TZ) {
 Name (KELV, 2732)
 Name (THOT, 800)
 Name (TCRT, 850)
 ThermalZone(TZ00) {
  Method(_AC0,0) {
   Return(Add(0, 2730))
  }
  Method(_AL0,0) {
   Return(Package() {\_TZ.TZ00.FAN0})
  }
  Device (FAN0) {
   Name(_HID, EISAID("PNP0C0B"))
   Name(_PR0, Package() {PFN0})
  }
  PowerResource(PFN0,0,0) {
   Method(_STA) {
    Store(0xF,Local0)
    Return(Local0)
   }
   Method(_ON) {
   }
   Method(_OFF) {
   }
  }
  Method(_HOT,0) {
   Return (Add (THOT, KELV))
  }
  Method(_CRT,0) {
   Return (Add (TCRT, KELV))
  }
  Method(_TMP,0) {
   Store (SMBR (0x07, 0x4C,, 0x00), Local0)
   If (LGreater (Local0, 0x10)) {
    Store (Local0, Local1)
   }
   Else {
    Add (Local0, THOT, Local0)
    Return (Add (400, KELV))
   }
   Store (SMBR (0x07, 0x4C, 0x01), Local0)
   If (LGreater (Local0, 0x10)) {
    If (LGreater (Local0, Local1)) {
     Store (Local0, Local1)
    }
    Multiply (Local1, 10, Local1)
    Return (Add (Local1, KELV))
   }
   Else {
    Add (Local0, THOT, Local0)
    Return (Add (400 , KELV))
   }
  }
 }
}
}
